# General Functions

### Data transformation

|                                                                                            |                                                                                                 |
| ------------------------------------------------------------------------------------------ | ----------------------------------------------------------------------------------------------- |
| [`merge`](https://danfo.jsdata.org/api-reference/general-functions/danfo.merge)            | Merge DataFrame or named Series objects with a database-style join.                             |
| [`concat`](https://danfo.jsdata.org/api-reference/general-functions/danfo.concat)          | Concatenate danfo objects along a particular axis with optional set logic along the other axes. |
| [`getDummies`](https://danfo.jsdata.org/api-reference/general-functions/danfo.get_dummies) | Convert categorical variable into dummy/indicator variables. Similar to OneHotEncoding          |

### Data Normalization

| [LabelEncoder](https://danfo.jsdata.org/api-reference/general-functions/danfo.labelencoder)     | Encode target labels with value between 0 and n\_classes-1.            |
| ----------------------------------------------------------------------------------------------- | ---------------------------------------------------------------------- |
| [OneHotEncoder](https://danfo.jsdata.org/api-reference/general-functions/danfo.onehotencoder)   | Encode categorical features as a one-hot numeric array.                |
| [StandardScaler](https://danfo.jsdata.org/api-reference/general-functions/danfo.standardscaler) | Standardize features by removing the mean and scaling to unit variance |
| [`MinMaxScaler`](https://danfo.jsdata.org/api-reference/general-functions/danfo.minmaxscaler)   | Transform features by scaling each feature to a given range            |

### Working with DateTime

| [`toDateTime`](https://danfo.jsdata.org/api-reference/general-functions/danfo.to_datetime) | Convert argument to datetime.                                                                        |
| ------------------------------------------------------------------------------------------ | ---------------------------------------------------------------------------------------------------- |
| [`dateRange`](https://danfo.jsdata.org/api-reference/general-functions/danfo.date_range)   | Return a fixed frequency Datetime Index.                                                             |
| [Dt](https://danfo.jsdata.org/api-reference/general-functions/danfo.dt)                    | A class that converts strings of Date Time into a usable format, by exposing various helper methods. |

### Streaming Functions

| [streamCSV](https://danfo.jsdata.org/api-reference/general-functions/danfo.streamcsv)                                        | A function that loads a CSV object as a stream, returning intermediate rows as a DataFrame.             |
| ---------------------------------------------------------------------------------------------------------------------------- | ------------------------------------------------------------------------------------------------------- |
| [streamJSON](https://danfo.jsdata.org/api-reference/general-functions/danfo.streamjson)                                      | A function that loads a JSON object as a stream, returning intermediate rows as a DataFrame.            |
| [streamCSVTransformer](https://danfo.jsdata.org/api-reference/general-functions/danfo.streamcsvtransformer)                  | A function that loads a CSV object as a stream, and applies a map-reduce function to intermediate rows. |
| [convertFunctionTotransformer](https://danfo.jsdata.org/api-reference/general-functions/danfo.-convertfunctiontotransformer) | A function to convert any JS function into a Stream transformer.                                        |

### Utility and Configurations

| [Utils](https://danfo.jsdata.org/api-reference/general-functions/danfo.utils)                                                  | A utility class with helper methods mostly used internally. |
| ------------------------------------------------------------------------------------------------------------------------------ | ----------------------------------------------------------- |
| [Config](https://github.com/javascriptdata/danfojs-doc/blob/master/api-reference/general-functions/broken-reference/README.md) | Base configuration class for NDframe objects                |

### Strings

| [Str](https://danfo.jsdata.org/api-reference/general-functions/danfo.str) | A class that converts strings into a usable format, by exposing various helper methods. |
| ------------------------------------------------------------------------- | --------------------------------------------------------------------------------------- |

### Internal Libs

| [tensoflow](https://danfo.jsdata.org/api-reference/general-functions/danfo.tensorflow) | Exported Tensorflow\.js library. This helps to avoid duplicated Tensorflow\.js library use. |
| -------------------------------------------------------------------------------------- | ------------------------------------------------------------------------------------------- |


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://danfo.jsdata.org/api-reference/general-functions.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
